from django.db import models


class Load(models.Model):
    """Load Model Class.

    Attributes
    ----------
    vc_tag : CharField
        The VC Tag as generated by the VCG
    date : DateTimeField
        The time on which the request is created

    """
    vc_tag = models.CharField(help_text='The VC Tag as generated by the VCG', max_length=100)
    date = models.DateTimeField(help_text='The time on which the request is created')

    class Meta:
        order_with_respect_to = 'date'

    def __str__(self):
        return 'DATE: %s | VC_TAG: %s' % (self.date, self.vc_tag)


class LoadValue(models.Model):
    """Load Value Model Class.

    Attributes
    ----------
    load : ForeignKey to Load
        The Load object of this LoadValue
    parameter : CharField
        The name of the load characteristic
    value : FloatField
        The value quantifying the load characteristic
    uom : CharField
        The unit of measurement of the value depending on the parameter

    """
    LOAD_PARAMETERS = (
        ('cpu', 'cpu'),
        ('ram', 'ram'),
        ('disk', 'disk')
    )

    load = models.ForeignKey(Load, related_name='load_values', on_delete=models.CASCADE)
    parameter = models.CharField(help_text='The name of the load characteristic', choices=LOAD_PARAMETERS, max_length=5)
    value = models.FloatField(help_text='The value quantifying the load characteristic')
    uom = models.CharField(help_text='The unit of measurement of the value depending on the parameter', max_length=5)

    class Meta:
        order_with_respect_to = 'load'

    def __str__(self):
        return 'PARAMETER: %s | VALUE: %s | UOM: %s' % (self.parameter, self.value, self.uom)


class Migration(models.Model):
    """Migration Model Class.

    Attributes
    ----------
    load : ForeignKey to Load
        The Load object of this LoadValue
    status : CharField
        The migration status
    marketaction : IntegerField
        The ID of the market action corresponding to migration
    action_type : CharField
        The type of market action placed on the Catalyst ITLM
    price : FloatField
        The price suggested for the migration action

    """
    MIGRATION_STATUSES = (
        ('pending', 'Migration is pending'),
        ('posted', 'Migration has been posted'),
        ('rejected', 'Migration was rejected'),
        ('started', 'Migration has started'),
        ('success', 'Migration succeeded'),
        ('failed', 'Migration has failed'),
    )
    ACTION_TYPES = (
        ('bid', 'bid'),
        ('offer', 'offer')
    )

    load = models.ForeignKey(Load, related_name='migrations', on_delete=models.CASCADE)
    status = models.CharField(help_text='The migration status', choices=MIGRATION_STATUSES, max_length=10)
    marketaction = models.IntegerField(help_text='The ID of the market action corresponding to migration',
                                       blank=True, null=True)
    action_type = models.CharField(help_text='The type of market action placed on the Catalyst ITLM',
                                   choices=ACTION_TYPES, max_length=6)
    price = models.FloatField(help_text='The price suggested for the migration action')

    class Meta:
        ordering = ['load', 'marketaction']

    def __str__(self):
        return 'MARKETACTION: %s | ACTION_TYPE: %s | PRICE: %s | STATUS: %s' % \
               (self.marketaction, self.action_type, self.price, self.status)


class MigrationDetails(models.Model):
    """Migration Details Model Class.

    Attributes
    ----------
    marketaction : IntegerField
        The ID of the market action corresponding to the migration
    source : CharField
        The username of the migration's source DC as understood by the DCMC Server
    destination : CharField
        The username of the destination DC as understood by the DCMC Server
    delivery_start : DateTimeField
        The time on which the migration is planned to start
    delivery_end : DateTimeField
        The time on which the remote execution is planned to end
    transaction : IntegerField
        The ID of the transaction as kept in the CATALYST IT Load Marketplace

    """
    marketaction = models.IntegerField(help_text='The ID of the market action corresponding to the migration')
    source = models.CharField(help_text='The username of the migration\'s source DC as understood by the DCMC Server',
                              max_length=30)
    destination = models.CharField(help_text='The username of the destination DC as understood by the DCMC Server',
                                   max_length=30)
    delivery_start = models.DateTimeField(help_text='The time on which the migration is planned to start')
    delivery_end = models.DateTimeField(help_text='The time on which the remote execution is planned to end')
    transaction = models.IntegerField(help_text='The ID of the transaction as kept in the CATALYST IT Load Marketplace')

    class Meta:
        order_with_respect_to = 'marketaction'

    def __str__(self):
        return 'MARKETACTION: %s | SOURCE: %s | DESTINATION: %s | DELIVERY_START: %s | DELIVERY_END %s' % \
               (self.marketaction, self.source, self.destination, self.delivery_start, self.delivery_end)


class MigrationOperationalDetails(models.Model):
    """Migration Operational Details Model Class.

    Attributes
    ----------
    vcontainer_uuid : CharField
        UUID of VContainer under Migration
    source_cmp : CharField
        The hostname of the source CMP node
    source_cmp_ip : CharField
        The IP of the source CMP node
    destination_cmp : CharField
        The hostname of the destination CMP node
    destination_cmp_ip : CharField
        The IP of the destination CMP node
    transaction : IntegerField
        The ID of the transaction as kept in the CATALYST IT Load Marketplace

    """
    vcontainer_uuid = models.CharField(max_length=100, help_text='UUID of VContainer Under Migration')
    source_cmp = models.CharField(max_length=30, help_text='Hostname of source CMP')
    source_cmp_url = models.CharField(max_length=30, help_text='VPN IP of source CMP')
    is_source_cmp_ready = models.BooleanField(default=False, help_text='Is source CMP ready for migration?')
    destination_cmp = models.CharField(max_length=30, help_text='Hostname of destination CMP', blank=True, null=True)
    destination_cmp_url = models.CharField(max_length=30, help_text='VPN IP of destination CMP', blank=True, null=True)
    is_destination_cmp_ready = models.BooleanField(default=False, help_text='Is destination CMP ready for migration?')
    transaction = models.IntegerField(help_text='The ID of the transaction as kept in the CATALYST IT Load Marketplace')

    class Meta:
        order_with_respect_to = 'transaction'

    def __str__(self):
        return 'TRANSACTION: %s | SOURCE_CMP: %s [%s] | DESTINATION_CMP: %s [%s]' % \
               (self.transaction, self.source_cmp, self.source_cmp_url, self.destination_cmp, self.destination_cmp_url)


class VContainer(models.Model):
    """ vContainer Model Class.

    Attributes
    ----------
    cpu : IntegerField
        The number of CPU cores of the VC described
    cpu_uom : CharField
        The unit of measurement for the CPU value
    ram : IntegerField
        The amount of RAM of the VC described
    ram_uom : CharField
        The unit of measurement for the RAM value
    disk : IntegerField
        The amount of disk of the VC described
    disk_uom : CharField
        The unit of measurement for the disk value
    start : DateTimeField
        The time from which the VC is planned to be active
    end : DateTimeField
        The time until which the VC is planned to be active
    transaction : IntegerField
        The ID of the transaction as kept in the CATALYST IT Load Marketplace
    status : CharField
        The status of the VC
    uuid : CharField
        Identification information of the issuing VM
    covpn_owner: CharField
        Cloud OpenVPN Connection Initiator

    """
    VC_STATUSES = (
        ('created', 'VC has been created'),
        ('registered', 'VC has been registered')
    )

    cpu = models.IntegerField(help_text='The number of CPU cores of the VC described')
    cpu_uom = models.CharField(help_text='The unit of measurement for the CPU value', max_length=5)
    ram = models.IntegerField(help_text='The amount of RAM of the VC described')
    ram_uom = models.CharField(help_text='The unit of measurement for the RAM value', max_length=5)
    disk = models.IntegerField(help_text='The amount of disk of the VC described')
    disk_uom = models.CharField(help_text='The unit of measurement for the disk value', max_length=5)
    start = models.DateTimeField(help_text='The time from which the VC is planned to be active')
    end = models.DateTimeField(help_text='The time until which the VC is planned to be active')
    transaction = models.IntegerField(help_text='The ID of the transaction as kept in the CATALYST IT Load Marketplace')
    status = models.CharField(help_text='The status of the VC', choices=VC_STATUSES, max_length=10,
                              blank=True, null=True)
    uuid = models.CharField(help_text='Identification information of the issuing VM', max_length=100,
                            blank=True, null=True)
    covpn_owner = models.CharField(help_text='Owner of VPN connection for the vContainer to connect to', max_length=32,
                                   blank=True, null=True)

    class Meta:
        order_with_respect_to = 'transaction'

    def __str__(self):
        return 'TRANSACTION: %s | UUID: %s | FLAVOR: %s-%s-%s | STATUS: %s' % \
               (self.transaction, self.uuid, self.cpu, self.ram, self.disk, self.status)


class Hypervisor(models.Model):
    """Hypervisor Model Class.

    Attributes
    ----------
    host_ip : CharField
        The IP of the Hypervisor's Host
    host_name : CharField
        The name of the Hypervisor's Host
    public_ssh_key : CharField
        The public SSH Key of the Hypervisor's Host
    vpn_ip :  CharField
        The VPN IP of the Hypervisor

    """
    host_ip = models.CharField(max_length=16, unique=True, help_text='The Hypervisor\'s Host IP')
    host_name = models.CharField(max_length=30, unique=True, help_text='The Hypervisor\'s Host Name')
    public_ssh_key = models.CharField(max_length=2048, help_text='The Hypervisor\'s Public SSH Key', blank=True, null=True)
    vpn_ip = models.CharField(max_length=16, help_text='The Hypervisor\'s VPN IP', blank=True, null=True)

    class Meta:
        order_with_respect_to = 'host_name'
        unique_together = ('host_ip', 'host_name')

    def __str__(self):
        return 'HOST_NAME: %s | HOST_IP: %s | VPN_IP: %s' % (self.host_name, self.host_ip, self.vpn_ip)
